/*********************************************************************************
 *                                                                               *
 * kizkool.c                                                                   *
 *                                                                               *
 * This code has been developped by KizKoool and others for Multidec-SE          *
 * and adapted by Keuleu for xawdecode                                           *
 *                                                                               *
 *                                                                               *
 * This program is free software; you can redistribute it and/or                 *
 * modify it under the terms of the GNU General Public License                   *
 * as published by the Free Software Foundation; either version 2                *
 * of the License, or (at your option) any later version.                        *
 *                                                                               *
 *                                                                               *          
 * This program is distributed in the hope that it will be useful,               *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
 * GNU General Public License for more details.                                  *
 *                                                                               *
 *                                                                               *
 * You should have received a copy of the GNU General Public License             *
 * along with this program; if not, write to the Free Software                   *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.    *
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html                *
 *                                                                               *
 *                                                                               *
 *********************************************************************************/
#include "config.h"
#include "filtre.h"
#include "kizkool.h"

#ifndef DISABLE_ALL_KIZKOOL

int TypeImage = 0;
unsigned int CurrentFrame = 1;
int CurrentX = 0;
int MovieScale = 0;

KIZKOOL_PARAM kizkool_param[NB_KIZKOOL_FILTER];

#ifdef ENABLE_SNABRAB
 SNABRAB_PARAM snabrab_param;
#endif

void
init_kizkool_filter (void)
{
  memset (kizkool_param, 0, NB_KIZKOOL_FILTER * sizeof (KIZKOOL_PARAM));

#ifdef ENABLE_SNABRAB
  memset (&snabrab_param, 0, sizeof (SNABRAB_PARAM));
#endif

#ifdef ENABLE_KIZKOOL25
  init_kizkool25_filter();
#endif

#ifdef ENABLE_KIZKOOL28
  init_kizkool28_filter();
#endif

#ifdef ENABLE_KIZKOOL30
  init_kizkool30_filter ();
#endif

#ifdef ENABLE_KIZKOOL31
  init_kizkool31_filter ();
#endif

#ifdef ENABLE_KIZKOOL32
  init_kizkool32_filter ();
#endif

#ifdef ENABLE_SNABRAB
  init_kizkool32snabrab_filter ();
#endif
}

#endif // DISABLE_KIZKOOL_FILTERS
