#include "oldcrypt.h"
#include "edge.h"
#include <sys/time.h>
#include <unistd.h>
#include "ch5.h"
#include "memcpy.h"
extern int h_offset[288];
extern unsigned char blackline[1660 * 2];    // das braucht man nicht mal zu initialisieren, weil Nullen
// int color_index_left[288],color_index_right[288];
int color_index_left2[288], color_index_right2[288];
extern int burst_phase;
extern int scryptphase;
extern int findShift_asm (unsigned char *baseline, unsigned char *line,
                          int xWidth, int skip);
//-----------------------------------------------
void
rotateFirstHalfLineoldcrypt (unsigned char *line, int shift, int xWidth,
                             int skip)
{
  unsigned char tmp[1660];

  if (shift == 0)
    return;

  if (shift > 0)                // nach links
    {
      fast_memcpy (tmp, line, xWidth * 2);
      fast_memcpy (&line[2 * skip], &tmp[2 * (skip + shift)],
              2 * (xWidth - skip - shift));
      fast_memcpy (&line[2 * (xWidth - shift)], &tmp[2 * skip], 2 * shift);
    }
  else                            // nach rechts
    {
      shift = -shift;
      fast_memcpy (tmp, line, xWidth * 2);
      fast_memcpy (&line[2 * skip], &tmp[2 * (xWidth - shift)], 2 * shift);
      fast_memcpy (&line[2 * (skip + shift)], &tmp[2 * skip],
              2 * (xWidth - shift));
    }
}

//------------------------------------------------
int
findShiftoldcrypt (unsigned char *baseline, unsigned char *line, int xWidth,
                   int skip)
{
  unsigned int k, best_shift = 0, bs, step;
  unsigned long int s, ls;
  unsigned char tbl[1660 * 2], tl[1660 * 2];

  fast_memcpy (tbl, &baseline[2 * skip], 2 * (xWidth - skip));
  fast_memcpy (tl, &line[2 * skip], 2 * (xWidth - skip));
  fast_memcpy (&tl[2 * (xWidth - skip)], &line[2 * skip], 2 * (xWidth - skip));

  // TOO SLOW

  step = 6;                        // ca. 2*step^2=384-SKIP --> step=14
  ls = 0xffffffff;
  for (k = 0; k < (xWidth - skip); k += step)
    {
      s = line_diff (tbl, &tl[2 * k], xWidth - skip);
      if (s < ls)
        {
          best_shift = k;
          ls = s;
        }
    }

  bs = best_shift;
  if (bs < step)
    bs = step;
  if (bs > (xWidth - step - skip))
    bs = xWidth - step - skip;
  best_shift = 0;                // TOO SLOW
  ls = 0xffffffff;
  for (k = bs - step; k < bs + step; k++)
    {
      s = line_diff (tbl, &tl[2 * k], xWidth - skip);
      if (s < ls)
        {
          best_shift = k;
          ls = s;
        }
    }

  return (best_shift);
}

//-------------------------------------------------
unsigned long int
line_diff (unsigned char *bline, unsigned char *line, int width)
{
  unsigned long int s = 0, li, bi;
  int k;

  for (k = 0; k < width; k += 2)
    {
      bi = (unsigned long int) bline[2 * k];
      li = (unsigned long int) line[2 * k];
      s += (bi - li) * (bi - li);
    }

  return (s);
}

//-------------------------------------------------
void
decodeFrameVC (unsigned char *buffer, int xBufferWidth, int yBorderHeight,
               int skipit)
{
//struct timeval t1,t2;
//double elapsed;

//gettimeofday(&t1,0);

// es wird vorausgesetzt, dass das bild mit (x,576) gegrabbt wurde
// yBorderHeight ist die hoehe der schwarzen balken oben bzw. unten
// es werden nur die geraden halbzeilen (288) decodiert , spaeter auf die ungeraden kopiert

  int skip = 0;
  int i, j;

  if (xBufferWidth > 880)
    return;
  scryptphase = get_burst (buffer, xBufferWidth);

  // breite des clear + garbage bereich
//skip=20*xBufferWidth/768;             // das ist kritisch ! bei 768->20 , bei 384->10 , sonst ??
  skip = skipit;

  for (i = 0; i < 288; i++)
    h_offset[i] = 0;

  for (i = yBorderHeight; i < (287 - yBorderHeight); i++)
    {
      j =
        findShift_asm (&buffer[2 * i * 2 * xBufferWidth],
                       &buffer[2 * (i + 1) * 2 * xBufferWidth], xBufferWidth,
                       skip);
      if (j % 2 == 0)
        j += 1;
      rotateFirstHalfLineoldcrypt (&buffer[2 * (i + 1) * 2 * xBufferWidth], j,
                                   xBufferWidth, skip);
      h_offset[i + 1] = j;
    }

  edgeCorrection (buffer, xBufferWidth, skip, yBorderHeight);

  for (i = yBorderHeight; i < (288 - yBorderHeight); i++)
    fast_memcpy (&buffer[(2 * i + 1) * 2 * xBufferWidth],
            &buffer[(2 * i) * 2 * xBufferWidth], 2 * xBufferWidth);


  for (i = 0; i < yBorderHeight; i++)
    fast_memcpy (&buffer[2 * i * 2 * xBufferWidth], blackline, 4 * xBufferWidth);
  for (i = 287 - yBorderHeight; i < 288; i++)
    fast_memcpy (&buffer[2 * i * 2 * xBufferWidth], blackline, 4 * xBufferWidth);

//gettimeofday(&t2,0);  
//elapsed=(t2.tv_sec+t2.tv_usec/1.0e6) - (t1.tv_sec+t1.tv_usec/1.0e6);  
//printf("vc_decode_time: %.3f  vc_decode_fps: %.3f\n",elapsed,1/elapsed);

  make_color_index ();

}

//-----------------------------------------------
