.set STEP,  8
.set X_INC, 2

.lcomm tmpline,  1536*2
.lcomm tmpbline, 1536*2

##    baseline     8(%ebp)
##    line        12(%ebp)
##    xsize       16(%ebp)
##    skip        20(%ebp)
##    ls          -4(%ebp)
##    best_shift  -8(%ebp)
##    bs         -12(%ebp)

.text

.global findShift_asm # int findShift_asm(unsigned char *baseline, unsigned char *line, int xsize, int skip)

.macro  corr_line
l1_\@:  movq    (%esi,%ecx),%mm0        # bi -> mm0
        movq    (%edi,%ecx),%mm1        # li -> mm1
        psubw   %mm1,%mm0               # bi-li
        pmaddwd %mm0,%mm0               # (bi-li)*(bi-li)
        addl    $X_INC*8, %ecx
        paddd   %mm0,%mm2
        cmpl    %ebx,%ecx
        jl      l1_\@
.endm

.macro  correlation p1, p2
        movl    $tmpbline, %esi
k1_\@:  xorl    %ecx,%ecx
        psllq   $64,%mm2                # mm2 = s = 0
        leal    tmpline(,%edx,2),%edi

        corr_line

        movq    %mm2,%mm3
        psrlq   $32,%mm3
        paddd   %mm2,%mm3
        movd    %mm3,%eax
        cmpl    -4(%ebp), %eax          # ls
        jae     m1_\@
        movl    %edx, -8(%ebp)          # best_shift
        movl    %eax, -4(%ebp)          # ls

m1_\@:  addl    $\p2, %edx
        cmpl    \p1, %edx
        jb      k1_\@
.endm

findShift_asm: 
        pushl %ebp
        movl  %esp,%ebp
        subw  $12,%sp
        pushl %ebx
        pushl %ecx
        pushl %edx
        pushl %esi
        pushl %edi

        movl    16(%ebp), %eax          # xsize
        subl    20(%ebp), %eax          # skip
        movl    %eax, 16(%ebp)          # xsize

        movl    8(%ebp), %esi           # baseline
        addl    20(%ebp), %esi          # skip
        addl    20(%ebp), %esi          # skip
        subl    $4,%esi
        movl    $tmpbline-4, %edi
        movl    16(%ebp), %ecx          # xsize
        shrl    %ecx
        movl    %ecx,%edx
findShift_asm.s1: movl    (%esi,%ecx,4),%eax
        andl    $0x00ff00ff,%eax
        movl    %eax,(%edi,%ecx,4)
        loop    findShift_asm.s1

        movl    12(%ebp), %esi          # line
        addl    20(%ebp), %esi          # skip
        addl    20(%ebp), %esi          # skip
        subl    $4,%esi
        movl    $tmpline-4, %edi

        movl    %edx,%ecx
        movl    %edi,%ebx
        addl    16(%ebp), %ebx          # xsize
        addl    16(%ebp), %ebx          # xsize
findShift_asm.s2: movl    (%esi,%ecx,4),%eax
        andl    $0x00ff00ff,%eax
        movl    %eax,(%edi,%ecx,4)
        movl    %eax,(%ebx,%ecx,4)
        loop    findShift_asm.s2

        movl    $0xffffffff, -4(%ebp)   # ls
        movl    $0, -8(%ebp)            # best_shift 
        xorl    %edx,%edx               # k = 0 = edx
        movl    16(%ebp), %ebx          # xsize
        shll    %ebx

        correlation 16(%ebp), STEP      # xsize, STEP

        movl    16(%ebp), %eax          # xsize
        subl    $STEP, %eax
        movl    -8(%ebp), %edx          # best_shift
        cmpl    $STEP, %edx             # if (bs<step)
        jae     findShift_asm.m2
        movl    $STEP, %edx             # bs=STEP
findShift_asm.m2: cmpl    %eax,%edx     # if (bs>384-SKIP-STEP)
        jbe     findShift_asm.m3
        movl    %eax,%edx               # bs=384-SKIP-STEP

findShift_asm.m3: movl $0, -8(%ebp)     # best_shift
        movl    $0xffffffff, -4(%ebp)   # ls
        movl    %edx,%eax
        subl    $STEP, %edx             # k=bs-step 
        movl    16(%ebp), %ebx          # xsize
        shll    %ebx
        addl    $STEP, %eax
        movl    %eax, -12(%ebp)         # bs

        correlation -12(%ebp), 1        # bs, 1

        movl    -8(%ebp), %eax          # best_shift

        emms
        popl %edi
        popl %esi
        popl %edx
        popl %ecx
        popl %ebx
        leave
        ret


